//
// https://www.ramecera.it/myscrewdriver.html
// e-mail: screwdriver@ramecera.it
//
/* This program and the accompanying materials are made available under
 * the terms of the Eclipse Public License v1.0 which accompanies this
 * distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html */
package it.ramecera.screwdriver.outfits;

/**
 * <p>
 * Elements forming a JSP.
 * </p>
 * <p>
 * Company: Ramecera™<br>
 * Creation date: 2020-04-09<br>
 * Last updated: 2020-04-09
 * </p>
 * <p>
 * Modifications:<br>
 * </p>
 * 
 * @author M. Maglioni */
final public class DBPlaceKit {

	/** the name of the schema DB */
	public String dbSchema;
	/** the name of the JNDI */
	public String jndiName;
	/** the name of the DBMS */
	public String dbms;

	/** default constructor */
	public DBPlaceKit() {
	}

	/**
	 * <p>
	 * Standard constructor.
	 * </p>
	 * <p>
	 * Creation date: 2020-04-09<br>
	 * Last updated: 2020-04-09
	 * </p>
	 * <p>
	 * Modifications:<br>
	 * </p>
	 * 
	 * @param dbSchema the name of the DB schema
	 * @param jndiName the name of the JNDI
	 * @param dbms the name of the DBMS */
	public DBPlaceKit(final String dbSchema, final String jndiName,
			final String dbms) {
		super();
		this.dbSchema = dbSchema;
		this.jndiName = jndiName;
		this.dbms = dbms;
	}
}
